#ifndef __ClockWork_H
#define __ClockWork_H

#include <windows.h>
#include "..\current\lsapi\lsapi.h"

#include "GuiWindow.h"
#include "Clickable.h"
#include "ClockFace.h"

#define MAX_LINE_LENGTH 4096

class ClockWork : public GuiWindow, Clickable
{
private:
	// for clock implementation:
	ClockFace clock;

	// borders
	int borderTop;
	int borderLeft;
	int borderRight;
	int borderBottom;
	BOOL borderDrag;

	// bitmaps, etc
	HBITMAP hbmSkin; // bitmap
	HBITMAP hbmBack; // created image
	HRGN hrgnBack;
	BOOL bTranspBack;
	BOOL bSkinTiled;
	BOOL bTranspSkin;

	// bg colors
	COLORREF clrBack;
	COLORREF clrBorder;

public:
	// for the Clickable class
	HWND GetHWND();

	ClockWork(HWND parentWnd, int& code, bool Wharfed);
	~ClockWork();

private:
	void DrawClock(HDC hdc);
	void CreateBackground();
	void PaintBackground( HDC hdcDst, HRGN hrgnDst );
	int CopyBlt (HDC hdcDst, int xDst, int yDst, int cxDst, int cyDst, HDC hdcSrc, int xSrc, int ySrc);
	int SizeBlt (HDC hdcDst, int xDst, int yDst, int cxDst, int cyDst, HDC hdcSrc, int xSrc, int ySrc, int cxSrc, int cySrc);
	void ReadSizeAndPos();
	void ReadGUIProps();

	virtual void windowProc(Message& message);

	//void onRefresh(Message& message);
	void onCreate(Message& message);
	void onDestroy(Message& message);
	//void onDisplayChange(Message& message);
	void onPaint(Message& message);
	//void onWindowActivated(Message& message);
	//void onWindowPosChanging(Message& message);
	void onEndSession(Message& message);
	void onGetRevId(Message& message);
	void onSysCommand(Message& message);
	void onTimer(Message& message);

	void onMouse(Message& message);
	/*void onLButtonDblClk(Message& message);
	void onLButtonDown(Message& message);
	void onLButtonUp(Message& message);
	void onRButtonDblClk(Message& message);
	void onRButtonDown(Message& message);
	void onRButtonUp(Message& message);
	void onMButtonDblClk(Message& message);
	void onMButtonDown(Message& message);
	void onMButtonUp(Message& message);*/

};

void BangSetTime(HWND, LPCSTR);
void BangToggle(HWND, LPCSTR);
void BangHook(HWND, LPCSTR);
void BangSetOnTop(HWND, LPCSTR);
void BangToggleOnTop(HWND, LPCSTR);
void BangShow(HWND, LPCSTR);
void BangHide(HWND, LPCSTR);
void BangMove(HWND, LPCSTR);
void BangSize(HWND, LPCSTR);

extern "C"
{
  __declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
  __declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}

#endif
